module jp.ku6.bbs.action.ThreadBuildAction;

import jp.ku6.raptan.core;
import jp.ku6.bbs.constants;
import jp.ku6.bbs.logic.ThreadLogic;
import jp.ku6.bbs.form.ThreadBuildFrom;
import jp.ku6.bbs.view.ThreadBuildView;

/++
 + スレッド新規作成画面
 +/
class ThreadBuildAction
{
	/++
	 + コンストラクタ
	 +
	 + Params:
	 +  logic = スレッドのロジックオブジェクト
	 +/
	this(ThreadLogic logic)
	{
		logic_ = logic;
		form_ = new ThreadBuildFrom;
		view_ = new ThreadBuildView(form_);
	}

	/++
	 + メイン処理
	 +
	 + Params:
	 +  request = リクエスト
	 +  response = レスポンス
	 +
	 + Returns:
	 +  内部リダイレクト先のActionのパス
	 +/
	string execute(Request request, Response response)
	{
		// リクエストオブジェクトからフォームのデータを読み出し
		form_.loadFromRequest(request);

		// 初回表示を判定
		if (!form_.submit.isSubmitted)
			form_.reset(); // フォームを初期化
		else
		{
			// 入力エラーを判定
			if (!form_.hasError())
			{
				// 送信されたデータをデータベースに登録
				logic_.buildThread(form_.title.value, form_.name.value, form_.content.value);

				// 一覧ページにリダイレクト
				response.redirect = APPLICATION_ROOT_URI ~ "/ThreadList.html";

				return null;
			}
		}

		view_.print(&response.append);

		return null;
	}

private:

	// ロジック
	ThreadLogic logic_;

	// フォーム
	ThreadBuildFrom form_;

	// 表示処理
	ThreadBuildView view_;
}

