module jp.ku6.bbs.action.ThreadDetailAction;

import jp.ku6.raptan.core;
import jp.ku6.bbs.constants;
import jp.ku6.bbs.logic.ThreadLogic;
import jp.ku6.bbs.form.ResponseWriteForm;
import jp.ku6.bbs.view.ThreadDetailView;

/++
 + スレッド詳細画面
 +/
class ThreadDetailAction
{
	/++
	 + コンストラクタ
	 +
	 + Params:
	 +  logic = スレッドのロジックオブジェクト
	 +/
	this(ThreadLogic logic)
	{
		logic_ = logic;
		form_ = new ResponseWriteForm;
		view_ = new ThreadDetailView(form_);
	}

	/++
	 + メイン処理
	 +
	 + Params:
	 +  request = リクエスト
	 +  response = レスポンス
	 +
	 + Returns:
	 +  内部リダイレクト先のActionのパス
	 +/
	string execute(Request request, Response response)
	{
		// IDを取得
		uint id = request.getParameterAs!uint("id");

		// スレッド情報を取得
		view_.thread = logic_.selectById(id);
		if (view_.thread is null)
		{
			// スレッド一覧へリダイレクト
			response.redirect = APPLICATION_ROOT_URI ~ "/ThreadList.html";
			return null;
		}

		// 書き込みフォームにスレッドIDをセット
		form_.threadId.value = std.conv.to!string(id);

		// レスを取得
		view_.responses = logic_.selectResponsesById(id);

		// HTMLを出力
		view_.print(&response.append);

		return null;
	}

private:

	// ロジック
	ThreadLogic logic_;

	// フォーム
	ResponseWriteForm form_;

	// 表示処理
	ThreadDetailView view_;
}
