module jp.ku6.bbs.form.ResponseWriteForm;

import jp.ku6.sweets.form;
import jp.ku6.bbs.constants;

/++
 + レスポンス書き込みフォーム
 +/
class ResponseWriteForm : Form
{
	/// スレッドID
	HiddenField threadId;

	/// 名前
	TextInputField name;

	/// 内容
	TextInputField content;

	/// 送信ボタン
	SubmitField submit;

	/++
	 + コンストラクタ
	 +/
	this()
	{
		// テンプレートで使用するIDと、actionのURLを設定する
		super("responseWriteForm", APPLICATION_ROOT_URI ~ "/ResponseWrite.html");

		// スレッドID
		threadId = new HiddenField(this, "threadId");
		new IndexConverter(threadId, "");

		// 名前入力欄
		name = new TextInputField(this, "name", "名前");
		new RequiredValidator(name, REQUIRED_VALIDATOR_MESSAGE);
		new MaximumLengthValidator(name, MAXLENGTH_VALIDATOR_MESSAGE, 1024);

		// 内容入力欄
		content = new TextInputField(this, "content", "内容");
		new RequiredValidator(content, REQUIRED_VALIDATOR_MESSAGE);
		new MaximumLengthValidator(content, MAXLENGTH_VALIDATOR_MESSAGE, 10240);

		// 作成ボタン
		submit = new SubmitField(this, "submit", "書き込み");
	}

	/++
	 + フォームのリセット
	 +/
	void reset()
	{
		name.value = null;
		content.value = null;
	}
}
