module jp.ku6.bbs.view.ThreadDetailView;

import jp.ku6.format;
import jp.ku6.sweets.core;
import jp.ku6.sweets.extension;
import jp.ku6.sweets.utility;
import jp.ku6.bbs.constants;
import jp.ku6.bbs.form.ResponseWriteForm;
import jp.ku6.bbs.action.BaseView;
import jp.ku6.bbs.entity.ThreadEntity;
import jp.ku6.bbs.entity.ResponseEntity;

/++
 + スレッド詳細
 +/
class ThreadDetailView : BaseView
{
	/// スレッド
	ThreadEntity thread;

	/// レス一覧
	ForeachProcessor!(ResponseEntity) responses;

	/++
	 + コンストラクタ
	 +/
	this(ResponseWriteForm form)
	{
		super("/ThreadDetail.html");

		// フォームの表示処理をテンプレートにセット
		form.assignToSweets(contents_);

		contents_.assign("threadTitle", &threadTitleProcessor);

		contents_.assign("responses", &responses.process);
		contents_.assign("responseName", &responseNameProcessor);
		contents_.assign("responseContent", &responseContentProcessor);
		contents_.assign("responseRegistered", &responseRegisteredProcessor);
	}

private:

	// スレッドタイトル
	void threadTitleProcessor(SweetsPrinter printer, SweetsElement element, const(SweetsNode[]) children)
	{
		element.printStartTag(printer, false);
		printer(escape(thread.title));
		element.printEndTag(printer);
	}

	// 名前
	void responseNameProcessor(SweetsPrinter printer, SweetsElement element, const(SweetsNode[]) children)
	{
		element.printStartTag(printer, false);
		printer(escape(responses.current.name));
		element.printEndTag(printer);
	}

	// 内容
	void responseContentProcessor(SweetsPrinter printer, SweetsElement element, const(SweetsNode[]) children)
	{
		element.printStartTag(printer, false);
		printer(textToHtml(responses.current.content));
		element.printEndTag(printer);
	}

	// 登録日時
	void responseRegisteredProcessor(SweetsPrinter printer, SweetsElement element, const(SweetsNode[]) children)
	{
		element.printStartTag(printer, false);
		printer(jp.ku6.format.format("%Y年%m月%d日 %H時%M分%S秒", responses.current.registered));
		element.printEndTag(printer);
	}
}
