module jp.ku6.bbs.view.ThreadListView;

import jp.ku6.format;
import jp.ku6.sweets.core;
import jp.ku6.sweets.extension;
import jp.ku6.sweets.utility;
import jp.ku6.bbs.constants;
import jp.ku6.bbs.action.BaseView;
import jp.ku6.bbs.model.Thread;

/++
 + スレッド一覧画面表示制御
 +/
class ThreadListView : BaseView
{
	/// スレッド一覧
	ForeachProcessor!(Thread) threads;

	/++
	 + コンストラクタ
	 +/
	this()
	{
		super("/ThreadList.html");

		contents_.assign("threads", &threads.process);

		contents_.assign("title", &titleProcessor);
		contents_.assign("registered", &registeredProcessor);
		contents_.assign("responseCount", &responseCountProcessor);
		contents_.assign("updated", &updatedProcessor);
	}

private:

	// タイトル
	void titleProcessor(SweetsPrinter printer, SweetsElement element, const(SweetsNode[]) children)
	{
		string[string] attributes;
		attributes["href"] = APPLICATION_ROOT_URI ~ "/ThreadDetail.html?id=" ~ std.conv.to!string(threads.current.id);

		element.printStartTagWithAdditionalAttributes(printer, attributes, false);
		printer(escape(threads.current.title));
		element.printEndTag(printer);
	}

	// 登録日時
	void registeredProcessor(SweetsPrinter printer, SweetsElement element, const(SweetsNode[]) children)
	{
		element.printStartTag(printer, false);
		printer(jp.ku6.format.format("%Y-%m-%d %H:%M:%S", threads.current.registered));
		element.printEndTag(printer);
	}

	// レス数
	void responseCountProcessor(SweetsPrinter printer, SweetsElement element, const(SweetsNode[]) children)
	{
		element.printStartTag(printer, false);
		printer(std.conv.to!string(threads.current.responseCount));
		element.printEndTag(printer);
	}

	// 最終更新日時
	void updatedProcessor(SweetsPrinter printer, SweetsElement element, const(SweetsNode[]) children)
	{
		element.printStartTag(printer, false);
		printer(jp.ku6.format.format("%Y-%m-%d %H:%M:%S", threads.current.updated));
		element.printEndTag(printer);
	}
}
